template<typename T>
T& BAS_MAGICARRAY<T>::Index(unsigned numdims, ...)
{
    va_list ap;
    va_start(ap,numdims);
    T& res = impl->Index(numdims, ap);
    va_end(ap);
    return res;
}

template<typename T>
void BAS_MAGICARRAY<T>::Redim(unsigned numdims, ...)
{
    va_list ap;
    va_start(ap,numdims);
    impl->Redim(numdims, ap);
    va_end(ap);
}

template<typename T>
BAS_MAGICARRAY<T>::BAS_MAGICARRAY(T* data, unsigned numdims, ...)
    : impl(new BAS_MAGICARRAY_ImplSTATIC<T>(data, numdims))
{
    va_list ap;
    va_start(ap, numdims);
    impl->InitDims(ap);
    va_end(ap);
}

template<typename T>
void BAS_MAGICARRAY_ImplSTATIC<T>::InitDims(va_list ap)
{
    for(unsigned a=0; a<dims.size(); ++a)
    {
        dims[a].first  = va_arg(ap, int);
        dims[a].second = va_arg(ap, unsigned);
    }
}

template<typename T>
T& BAS_MAGICARRAY_ImplSTATIC<T>::Index(unsigned numdims, va_list ap)
{
    if(numdims != num_dims)
    {
     trouble:
        B_ERROR(9); /* subscript out of range */
    }
    unsigned res_index = 0;
    for(unsigned a=0; a<num_dims; ++a)
    {
        int req_index = va_arg(ap, int);
        if(req_index < dims[a].first) goto trouble;
        req_index -= dims[a].first;
        if(req_index >= dims[a].second) goto trouble;
        res_index += req_index;
        if(a+1 < num_dims) res_index *= dims[a].second;
    }
    return data[res_index];
}

template<typename T>
void BAS_MAGICARRAY_ImplSTATIC<T>::Erase()
{
}

template<typename T>
long BAS_MAGICARRAY_ImplSTATIC<T>::Lbound(unsigned dimindex) const
{
}

template<typename T>
long BAS_MAGICARRAY_ImplSTATIC<T>::Ubound(unsigned dimindex) const
{
}

template<typename T>
unsigned BAS_MAGICARRAY_ImplSTATIC<T>::Volume() const
{
    unsigned res = 1;
    for(unsigned a=0; a<num_dims; ++a)
        res *= dims[a].second;
    return res;
}
